var e=require("dr-js/library/common/module/TimedLookup")
var a=require("dr-js/library/common/data/CacheMap")
var t=require("dr-js/library/node/net")
var r=require("dr-js/library/node/data/Buffer")
var u=require("dr-js/library/node/file/function")
exports.DEFAULT_AUTH_KEY="auth-check-code"
exports.AUTH_SKIP="auth-skip"
exports.AUTH_FILE="auth-file"
exports.AUTH_FILE_GROUP="auth-file-group"
const h=async a=>(0,e.parseDataArrayBuffer)((0,r.toArrayBuffer)(await(0,u.readFileAsync)(a)))
const o=async(a,r,u,h)=>{const o=await(0,t.fetchLikeRequest)(a,Object.assign({},r,{headers:Object.assign({[h]:(0,e.generateCheckCode)(u)},r.headers)}))
if(!o.ok)throw new Error(`[authFetch] status: ${o.status}`)
return o}
exports.configureAuthSkip=async({authKey:e="auth-check-code",logger:a,log:r=a&&a.add})=>{r&&r("auth skip enabled")
const u=async()=>"auth-skip"
return{authMode:"auth-skip",authKey:e,authFetch:t.fetchLikeRequest,checkAuth:()=>"auth-skip",generateAuthCheckCode:u,generateAuthHeader:u}}
exports.configureAuthFile=async({timedLookupData:a,authFile:t,authFileGenTag:r,authFileGenSize:i,authFileGenTokenSize:c,authFileGenTimeGap:n,authKey:s="auth-check-code",logger:d,log:l=d&&d.add})=>{if(!a){a=await h(t).catch(async a=>{if(!r){l&&l("missing auth file",a)
throw a}l&&l("generate new auth file")
const h=await(0,e.generateLookupData)({tag:r,size:i,tokenSize:c,timeGap:n})
await((a,t)=>(0,u.writeFileAsync)(a,Buffer.from((0,e.packDataArrayBuffer)(t))))(t,h)
return h})
l&&l("loaded auth file")}const g=()=>(0,e.generateCheckCode)(a)
return{authMode:"auth-file",authKey:s,authFetch:(e,t)=>o(e,t,a,s),checkAuth:t=>{(0,e.verifyCheckCode)(a,t)
return a.tag},generateAuthCheckCode:g,generateAuthHeader:g}}
exports.configureAuthFileGroup=async({authFileGroupPath:t,authFileGroupDefaultTag:r,authFileGroupKeySuffix:i,getFileNameForTag:c=(i?e=>`${e}${i}`:e=>`${e}.key`),authCacheExpireTime:n=3e5,authCacheMap:s=(0,a.createCacheMap)({valueSizeSumMax:8388608,eventHub:null}),authKey:d="auth-check-code",logger:l,log:g=l&&l.add})=>{const f=(0,u.createPathPrefixLock)(t)
const k=e=>s.get(e)||h(f(c(e))).then(a=>{s.set(e,a,a.dataView.byteLength,Date.now()+n)
g&&g(`loaded auth file for tag: ${e}`)
return a},a=>{g&&g(`no auth file for tag: ${e}`)
throw a})
const p=async(a=r)=>(0,e.generateCheckCode)(await k(a))
return{authMode:"auth-file-group",authKey:d,authFetch:async(e,a,t=r)=>o(e,a,await k(t),d),checkAuth:async a=>{const t=(0,e.parseCheckCode)(a)
const r=t[0]
const u=await k(r);(0,e.verifyParsedCheckCode)(u,t)
return u.tag},generateAuthCheckCode:p,generateAuthHeader:p}}
