var _configure = require("../library/feature/Auth/configure");
var _client = require("../library/feature/Explorer/task/client");
exports.startClient = async _ref => {
  let {modeName, log, authFile, authFileGenTag, authFileGenSize, authFileGenTokenSize, authFileGenTimeGap} = _ref, optionData = function(source, excluded) {
    if (null == source) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      excluded.indexOf(key) >= 0 || (target[key] = source[key]);
    }
    return target;
  }(_ref, [ "modeName", "log", "authFile", "authFileGenTag", "authFileGenSize", "authFileGenTokenSize", "authFileGenTimeGap" ]);
  const {authFetch} = await (0, _configure.configureAuthFile)({
    authFile,
    authFileGenTag,
    authFileGenSize,
    authFileGenTokenSize,
    authFileGenTimeGap,
    log
  });
  optionData.authFetch = authFetch;
  optionData.log = log;
  switch (modeName) {
   case "node-path-action":
    return (0, _client.pathAction)(optionData);
   case "node-file-upload":
    await (0, _client.fileUpload)(optionData);
    break;
   case "node-file-download":
    await (0, _client.fileDownload)(optionData);
  }
};