var t=require("path")
var s=require("child_process")
var e=require("dr-js/library/common/time")
var a=require("dr-js/library/common/verify")
var r=require("dr-js/library/node/file/function")
var o=require("dr-js/library/node/file/File")
var i=require("dr-js/library/node/file/Directory")
var n=require("dr-js/library/node/file/Modify")
var c=require("dr-js/library/node/system/ProcessStatus")
exports.TASK_ACTION_TYPE={TASK_CONFIG_SET:"task-config:set",TASK_CONFIG_GET:"task-config:get",TASK_START:"task:start",TASK_STOP:"task:stop",TASK_DELETE:"task:delete",TASK_LIST:"task:list",TASK_LOG_GET:"task-log:get",TASK_LOG_GET_TAIL:"task-log:get-tail",TASK_LOG_RESET:"task-log:reset",PROCESS_STATUS:"process-status"}
const l=/^\w[\w-.|]*$/
const d=(t,s)=>{if(!t)throw new Error(`missing ${s}`);(0,a.string)(t,`invalid ${s}`)
if(!t.length)throw new Error(`expect value in ${s}`)}
const y=async({status:t})=>t&&t.processInfo&&(0,c.isPidExist)(t.processInfo.pid)&&(0,c.findProcessPidMapInfo)(t.processInfo,(0,c.toProcessPidMap)(await(0,c.getProcessListAsync)()))
const k=t=>null
exports.createTaskAction=p=>{const f=(0,r.createPathPrefixLock)(p)
const u=s=>f((0,t.join)(s,"task.config.json"))
const w=s=>f((0,t.join)(s,"task.log"))
const g=t=>(0,r.writeFileAsync)(u(t.key),JSON.stringify(t))
const m=async t=>JSON.parse(await(0,r.readFileAsync)(u(t)))
const T={"task-config:set":async s=>{let i=(({key:s,task:o,info:i={}},n)=>{d(s,"key")
if(!l.test(s))throw new Error(`invalid key, get: ${s}, expect: ${l}`);(0,a.basicObject)(o,"invalid task")
const c=n(s)
const{command:y,argList:k=[],cwd:p=c,env:f={},shell:u=!0,resetLog:w=!0}=o
d(y,"task.command");(0,a.basicArray)(k,"invalid task.argList");(0,a.basicObject)(f,"invalid task.env");(0,a.boolean)(u,"invalid task.shell");(0,a.boolean)(w,"invalid task.resetLog")
o={command:y,argList:k,cwd:(0,r.toPosixPath)((0,t.relative)(c,(0,t.resolve)(c,p))),env:f,shell:u,resetLog:w};(0,a.basicObject)(i,"invalid info")
const{note:g}=i
const m=(0,e.getTimestamp)()
return{key:s,task:o,info:i={note:g,timeCreate:m,timeUpdate:m},status:null}})(s,f)
const n=await m(i.key).catch(k)
if(n&&await y(n))throw new Error("config task running")
n&&(i=((t,{key:s,task:e,info:a})=>({key:s,task:e,info:Object.assign({},a,{timeCreate:t.info.timeCreate}),status:null}))(n,i))
await(0,o.createDirectory)(f(i.key))
await g(i)},"task-config:get":({key:t})=>m(t).catch(k),"task:start":async({key:t})=>{const a=await m(t)
if(await y(a))throw new Error("task exist")
a.task.resetLog&&await T["task-log:reset"]({key:t})
const{processInfo:o}=await(async({command:t,argList:e,cwd:a,env:o,shell:i=!0},n)=>{const l=(0,s.spawn)(t,e,{stdio:["ignore",await(0,r.openAsync)(n,"a"),await(0,r.openAsync)(n,"a")],cwd:a,env:o,shell:i,detached:!0,windowsHide:!0})
l.on("error",s=>{console.warn("[ERROR][startDetachedProcess] config:",{command:t,argList:e,cwd:a,env:o,shell:i},"error:",s)})
l.unref()
{const t=await(0,c.getProcessListAsync)()
const s=(0,c.toProcessPidMap)(t)[l.pid]
if(!s||s.ppid!==process.pid)throw new Error(`sub process info not found, expect pid: ${l.pid}, ppid: ${process.pid}`)
const{pid:e,command:a,subTree:r}=(0,c.findProcessTreeInfo)(s,(0,c.toProcessTree)(t))
return{process:l,processInfo:{pid:e,command:a,subTree:r}}}})(a.task,w(t))
await g(Object.assign({},a,{status:{processInfo:o,timeStart:(0,e.getTimestamp)()}}))},"task:stop":async({key:t})=>{const s=await m(t)
s.status&&s.status.processInfo&&await(0,c.killProcessTreeInfoAsync)(s.status.processInfo)
await g(Object.assign({},s,{status:null}))},"task:delete":async({key:t})=>{const s=await m(t)
if(await y(s))throw new Error(`task process running at: ${s.status.processInfo.pid}`)
await n.modify.delete(f(t))},"task:list":async()=>{const t=[]
for(const s of await(0,i.getDirectorySubInfoList)(p).catch(()=>[])){const{name:e,stat:a}=s
const r=a.isDirectory()&&await m(e).catch(k)
r&&t.push(r)}return{configList:t}},"task-log:get":async({key:t})=>({stream:(0,r.createReadStream)(w(t))}),"task-log:get-tail":async({key:t,tailSize:s=4096})=>{const e=w(t)
const{size:a}=await(0,r.statAsync)(e)
return{stream:(0,r.createReadStream)(e,{start:Math.max(a-s,0)})}},"task-log:reset":async({key:t})=>(0,r.truncateAsync)(w(t)),"process-status":async({outputMode:t="tree",isHumanReadableOutput:s=!0})=>({processStatus:await(s?c.describeAllProcessStatusAsync:c.getAllProcessStatusAsync)(t)})}
return async(t,s)=>{const e=await T[t](s)
return Object.assign({type:t},e)}}
